#include<iostream>
#include<vector>
using namespace std;

int mapa_size[ 3 ] = { 0, 0, 0 };

struct mapa_node
{
    mapa_node()
    {
        przejscie[0][0] = 0;
        przejscie[0][1] = 0;
        przejscie[1][0] = 0;
        przejscie[1][1] = 0;
        przejscie[2][0] = 0;
        przejscie[2][1] = 0;
    }
	bool przejscie[ 3 ][ 2 ];
};

double gestosc_scian_x;
double gestosc_scian_y;
double gestosc_scian_z;

vector<mapa_node> mapa;
#define M(x,y,z) ((x) + (y)*mapa_size[ 0 ] + (z)*mapa_size[ 0 ]*mapa_size[ 1 ] )

int main()
{
    ios_base::sync_with_stdio(0);
    srand(1234);

    mapa_size[0] = 2;
    mapa_size[1] = 2;
    mapa_size[2] = 2;

    gestosc_scian_x = 0.0;
    gestosc_scian_y = 0.0;
    gestosc_scian_z = 0.0;




    cout<<mapa_size[0]<<" "<<mapa_size[1]<<" "<<mapa_size[2]<<endl;

    cout << rand() % mapa_size[0] << " " << rand() % mapa_size[1] << " " << rand() % mapa_size[2] << endl;

    mapa.resize(mapa_size[0]*mapa_size[1]*mapa_size[2]);

    for(int z = 0; z < mapa_size[2]-1; ++z)
    {
        for(int y = 0; y < mapa_size[1]-1; ++y)
        {
            for(int x = 0; x < mapa_size[0]-1; ++x)
            {
                if(rand()%1000 > gestosc_scian_x*1000)
                {
                    mapa[M(x,y,z)].przejscie[0][1] = 1;
                    mapa[M(x+1,y,z)].przejscie[0][0] = 1;
                }
                if(rand()%1000 > gestosc_scian_y*1000)
                {
                    mapa[M(x,y,z)].przejscie[1][1] = 1;
                    mapa[M(x,y+1,z)].przejscie[1][0] = 1;
                }
                if(rand()%1000 > gestosc_scian_z*1000)
                {
                    mapa[M(x,y,z)].przejscie[2][1] = 1;
                    mapa[M(x,y,z+1)].przejscie[2][0] = 1;
                }
            }
        }
    }



    for(int z = 0; z < mapa_size[2]; ++z)
    {
        for(int y = 0; y < mapa_size[1]; ++y)
        {
            for(int x = 0; x < mapa_size[0]; ++x)
            {
                for(int wymiar = 0; wymiar < 3; ++wymiar)
                {
                    for(int strona = 0; strona < 2; ++strona)
                    {
                        cout<<mapa[M(x,y,z)].przejscie[wymiar][strona]<<" ";
                    }
                    cout<<" ";
                }
                cout<<"\t";
            }

            cout<<endl;
        }

        cout<<endl<<endl;
    }

    return 0;
}
